/*
	grep.c
	Ver. 0.5
TODO
	return code:
	0	One or more lines were selected.
	1	No lines were selected.
	>1	An error occurred.
*/

#include	<stdio.h>
#define	MAXLINE	512	/* line size */

char *prog="grep";

/* strindex */
int strindex(char s[], char t[])
{
	int i, j, k;
	for (i=0; s[i] != '\0'; i++)
	{
		for (j=i, k=0; t[k]!='\0'&& s[j]==t[k]; j++, k++)
			;
		if (k>0 && t[k]=='\0')
			return i;
	}
	return -1;
}

int main(int argc, char *argv[])
{
	char linea[MAXLINE];
	int found = 0;
	int i = 0;
	char pattern[MAXLINE];
	char ifile[32];
	FILE *fi;

	if (argc < 3)
	{
		printf("usage: %s search-string input-file1 [input-fileN]\n",
			prog);
		return 1;
	}

	strcpy(pattern, argv[1]);

	for (i=2; i<argc; i++)
	{
		strcpy(ifile, argv[i]);

		if (argc > 3)
			printf("%s:\n", ifile);
		if ((fi=fopen(ifile, "r")) == NULL)
		{
			fprintf(stderr, "%s: can't open %s\n", prog, ifile);
			return 1;
		}

		while (fgets(linea, MAXLINE, fi) > 0)
			if (strindex(linea, pattern) >= 0)
			{
				printf("%s",linea);
				found++;
			}
	}
	return found;
}

/* EOT */
