/*
	mkdir.c
	makes directories
	Ver. 0.5
TODO
	-p	Create any missing intermediate pathname components.
	Exit status:
		0	All the specified directories were created successfully.
		>0	An error occurred.
*/
#include <stdio.h>
#include <sys/stat.h>

char *prog="mkdir";
extern int errno;

int usage()
{
	fprintf(stderr,"usage: %s dir [dir2 ... dirN]\n", prog);
	exit(1);
}

int main(int argc, char *argv[])
{
	int i;
	int status=0;
	int countErr=0;

	if (argc == 1)
		usage();

	for (i=1; i<argc; i++)
	{
		if (status=mkdir(argv[i], S_IRWXU|S_IRWXG|S_IROTH|S_IXOTH) != 0)
		{
			fprintf(stderr, "%s: error %d, can't create dir %s\n",
				prog, errno, argv[i]);
			++countErr;
		}
	}
	return countErr;
}
