/*
	rmdir.c
	makes directories
	Ver. 0.5
TODO
	-p	Remove all directories in a pathname. For each dir operand.
	RETURN STATUS:
	0	Each directory entry specified was removed successfully.
	>0	An error occurred.
*/
#include <stdio.h>
#include <unistd.h>

char *prog="rmdir";
extern int errno;

int usage()
{
	fprintf(stderr,"usage: %s dir [dir2 ... dirN]\n", prog);
	exit(1);
}

int main(int argc, char *argv[])
{
	int i;
	int status=0;
	int countErr=0;

	if (argc == 1)
		usage();

	for (i=1; i<argc; i++)
	{
		if (status=rmdir(argv[i]) != 0)
		{
			fprintf(stderr, "%s: error %d, can't remove dir %s\n",
				prog, errno, argv[i]);
			++countErr;
		}
	}
	return countErr;
}
